CBCBlockCipherMac (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.crypto.macs

## Class CBCBlockCipherMac

- java.lang.Object
- - org.bouncycastle.crypto.macs.CBCBlockCipherMac

- All Implemented Interfaces:
    Mac

      public class CBCBlockCipherMac
      extends java.lang.Object
      implements Mac

  standard CBC Block Cipher MAC - if no padding is specified the default of pad of zeroes is used.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CBCBlockCipherMac(BlockCipher cipher)` create a standard MAC based on a CBC block cipher.
    `CBCBlockCipherMac(BlockCipher cipher, BlockCipherPadding padding)` create a standard MAC based on a CBC block cipher.
    `CBCBlockCipherMac(BlockCipher cipher, int macSizeInBits)` create a standard MAC based on a block cipher with the size of the MAC been given in bits.
    `CBCBlockCipherMac(BlockCipher cipher, int macSizeInBits, BlockCipherPadding padding)` create a standard MAC based on a block cipher with the size of the MAC been given in bits.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `doFinal(byte[] out, int outOff)` Compute the final stage of the MAC writing the output to the out parameter.
    `java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the MAC implements.
    `int` | `getMacSize()` Return the block size for this MAC (in bytes).
    `void` | `init(CipherParameters params)` Initialise the MAC.
    `void` | `reset()` Reset the mac generator.
    `void` | `update(byte in)` add a single byte to the mac for processing.
    `void` | `update(byte[] in, int inOff, int len)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CBCBlockCipherMac

          public CBCBlockCipherMac(BlockCipher cipher)

      create a standard MAC based on a CBC block cipher. This will produce an authentication code half the length of the block size of the cipher.
      Parameters:
        `cipher` - the cipher to be used as the basis of the MAC generation.

    - #### CBCBlockCipherMac

          public CBCBlockCipherMac(BlockCipher cipher,
                                   BlockCipherPadding padding)

      create a standard MAC based on a CBC block cipher. This will produce an authentication code half the length of the block size of the cipher.
      Parameters:
        `cipher` - the cipher to be used as the basis of the MAC generation.
        `padding` - the padding to be used to complete the last block.

    - #### CBCBlockCipherMac

          public CBCBlockCipherMac(BlockCipher cipher,
                                   int macSizeInBits)

      create a standard MAC based on a block cipher with the size of the MAC been given in bits. This class uses CBC mode as the basis for the MAC generation.

      Note: the size of the MAC must be at least 24 bits (FIPS Publication 81), or 16 bits if being used as a data authenticator (FIPS Publication 113), and in general should be less than the size of the block cipher as it reduces the chance of an exhaustive attack (see Handbook of Applied Cryptography).

      Parameters:
        `cipher` - the cipher to be used as the basis of the MAC generation.
        `macSizeInBits` - the size of the MAC in bits, must be a multiple of 8.

    - #### CBCBlockCipherMac

          public CBCBlockCipherMac(BlockCipher cipher,
                                   int macSizeInBits,
                                   BlockCipherPadding padding)

      create a standard MAC based on a block cipher with the size of the MAC been given in bits. This class uses CBC mode as the basis for the MAC generation.

      Note: the size of the MAC must be at least 24 bits (FIPS Publication 81), or 16 bits if being used as a data authenticator (FIPS Publication 113), and in general should be less than the size of the block cipher as it reduces the chance of an exhaustive attack (see Handbook of Applied Cryptography).

      Parameters:
        `cipher` - the cipher to be used as the basis of the MAC generation.
        `macSizeInBits` - the size of the MAC in bits, must be a multiple of 8.
        `padding` - the padding to be used to complete the last block.

  - ### Method Detail

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `Mac`
      Return the name of the algorithm the MAC implements.
      Specified by:
        `getAlgorithmName` in interface `Mac`
      Returns:
        the name of the algorithm the MAC implements.

    - #### init

          public void init(CipherParameters params)

      Description copied from interface: `Mac`
      Initialise the MAC.
      Specified by:
        `init` in interface `Mac`
      Parameters:
        `params` - the key and other data required by the MAC.

    - #### getMacSize

          public int getMacSize()

      Description copied from interface: `Mac`
      Return the block size for this MAC (in bytes).
      Specified by:
        `getMacSize` in interface `Mac`
      Returns:
        the block size for this MAC in bytes.

    - #### update

          public void update(byte in)

      Description copied from interface: `Mac`
      add a single byte to the mac for processing.
      Specified by:
        `update` in interface `Mac`
      Parameters:
        `in` - the byte to be processed.

    - #### update

          public void update(byte[] in,
                             int inOff,
                             int len)

      Specified by:
        `update` in interface `Mac`
      Parameters:
        `in` - the array containing the input.
        `inOff` - the index in the array the data begins at.
        `len` - the length of the input starting at inOff.

    - #### doFinal

          public int doFinal(byte[] out,
                             int outOff)

      Description copied from interface: `Mac`
      Compute the final stage of the MAC writing the output to the out parameter.

      doFinal leaves the MAC in the same state it was after the last init.

      Specified by:
        `doFinal` in interface `Mac`
      Parameters:
        `out` - the array the MAC is to be output to.
        `outOff` - the offset into the out buffer the output is to start at.

    - #### reset

          public void reset()

      Reset the mac generator.
      Specified by:
        `reset` in interface `Mac`